import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import javafx.scene.layout.Background;
import javafx.scene.layout.BackgroundFill;
import javafx.scene.layout.CornerRadii;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.stage.Stage;

public class Driver extends Application {
	LinkedList<Book> library = new LinkedList<>();

	public void load() throws FileNotFoundException {
		File file = new File("file.txt");
		if (file.exists()) {
			Scanner input = new Scanner(file);
			// Read data from a file
			while (input.hasNextLine()) {
				
				String line = input.nextLine();
				
					
				String[] tokens = line.split(":");
				if(tokens.length>1){
				int price = Integer.parseInt(tokens[4].trim());
				int quntity = Integer.parseInt(tokens[5].trim());
				Book books = new Book(tokens[0].trim(), tokens[1].trim(), tokens[2].trim(), tokens[3].trim(), price, quntity);
				library.insertSorted(books);
				}
				
			}
			// Close the file
			input.close();
		}
	}

	public void start(Stage ps) throws FileNotFoundException {
		load();
		// Creating the main pane
		Pane pane = new Pane();
		pane.setBackground(new Background(new BackgroundFill(Color.LIGHTSLATEGRAY,CornerRadii.EMPTY,Insets.EMPTY)));
		VBox vBox = new VBox();
		vBox.setSpacing(20);
		// set margin around the VBox
		vBox.setPadding(new Insets(40, 90, 20, 90));
		//
		pane.getChildren().add(vBox);
		// creating Button
		Button addBook = new Button("Add Book");
		addBook.setDisable(true);
		addBook.setPrefWidth(200);

		// Button sale = new Button("Sale");
		Button display = new Button("Display");
		Button search = new Button("Search");
		Button report = new Button("Report");

		// Creating the HBox pane
		HBox hBox = new HBox();
		// add HBox to main pane
		vBox.getChildren().addAll(hBox);

		// set margin around the pane
		hBox.setPadding(new Insets(40, 20, 20, 0));
		// set space between elements in HBox
		hBox.setSpacing(20);
		// add all button to the HBox
		hBox.getChildren().addAll(addBook, display, search, report);

		// Add Book

		VBox vBoxAddBooklab = new VBox();
		Label authorlab = new Label("Author");
		Label titlelab = new Label("Title");
		Label editionlab = new Label("Edition");
		Label publisherlab = new Label("Publisher");
		Label pricelab = new Label("Price");
		Label quantitylab = new Label("Quantity");
		vBoxAddBooklab.getChildren().addAll(authorlab, titlelab, editionlab, publisherlab, pricelab, quantitylab);
		vBoxAddBooklab.setSpacing(28);

		VBox vBoxAddBookTextFeield = new VBox();
		TextField authorTF = new TextField();
		TextField titleTF = new TextField();
		TextField editionTF = new TextField();
		TextField publisherTF = new TextField();
		TextField priceTF = new TextField();
		TextField quantityTF = new TextField();
		Button addBookBut = new Button("Add Book To Store");
		addBookBut.setPrefSize(200, 12);
		Label doneError = new Label();
		HBox hDoneErroe = new HBox();
		hDoneErroe.getChildren().add(doneError);
		vBoxAddBookTextFeield.getChildren().addAll(authorTF, titleTF, editionTF, publisherTF, priceTF, quantityTF,
				addBookBut, hDoneErroe);

		vBoxAddBookTextFeield.setSpacing(20);
		HBox hBoxAddBook = new HBox();
		hBoxAddBook.getChildren().addAll(vBoxAddBooklab, vBoxAddBookTextFeield);
		hBoxAddBook.setSpacing(20);

		// Search
		HBox hBoxSearch = new HBox();
		Label labelSearch = new Label("Enter Book Name :");
		TextField searchTF = new TextField();
		searchTF.setPrefWidth(315);
		hBoxSearch.setSpacing(20);
		hBoxSearch.getChildren().addAll(labelSearch, searchTF);
		Button searchbut = new Button("Search");
		searchbut.setPrefWidth(435);
		VBox vBoxSearch = new VBox();
		vBoxSearch.setSpacing(20);
		vBoxSearch.getChildren().addAll(hBoxSearch, searchbut);
		HBox hblist = new HBox();
		ListView<String> listSerch = new ListView<>();
		listSerch.setPrefSize(435, 280);
		hblist.getChildren().add(listSerch);
		Button saleBut = new Button("Sale");
		saleBut.setPrefWidth(440);
		Label noSelectedBook = new Label("");
		vBoxSearch.getChildren().addAll(hblist, saleBut, noSelectedBook);
		// display
		HBox hboxdisplay = new HBox();
		ListView<String> listDisplay = new ListView<>();
		listDisplay.setPrefSize(420, 400);

		hboxdisplay.getChildren().add(listDisplay);

		// report
		HBox hBoxReport = new HBox();
		Label labelReport = new Label("Enter Password in order to save the changes:");
		PasswordField reportTF = new PasswordField();
		reportTF.setPrefWidth(165);
		hBoxReport.setSpacing(20);
		hBoxReport.getChildren().addAll(labelReport, reportTF);
		Button reportbut = new Button("Report");
		reportbut.setPrefWidth(420);
		Button reportAndExit =new Button("Report and exit");
		reportAndExit.setPrefWidth(420);
		VBox vBoxReport = new VBox();
		vBoxReport.setSpacing(20);
		vBoxReport.getChildren().addAll(hBoxReport, reportbut,reportAndExit);
		HBox hbReport = new HBox();
		vBoxReport.getChildren().add(hbReport);

		reportbut.setOnAction(e -> {
			hbReport.getChildren().clear();
			Label labReport = new Label();

			if (reportTF.getText().compareToIgnoreCase("0000") == 0) {
				try {
					library.downLoadInFile();

				} catch (Exception e1) {
					e1.printStackTrace();
				}
				labReport.setText("The changes were saved");
				labReport.setTextFill(Color.GREEN);

				reportTF.setText("");

			} else {
				labReport.setText("The password is incorrect, try again");
				labReport.setTextFill(Color.RED);

				reportTF.setText("");
			}

			hbReport.getChildren().add(labReport);

		});
		
reportAndExit.setOnAction(e->{
	hbReport.getChildren().clear();
	Label labReport = new Label();

	if (reportTF.getText().compareToIgnoreCase("0000") == 0) {
		try {
			library.downLoadInFile();

		} catch (Exception e1) {
			e1.printStackTrace();
		}
		labReport.setText("The changes were saved");
		labReport.setTextFill(Color.GREEN);
		reportTF.setText("");
		ps.close();
	} else {
		labReport.setText("The password is incorrect, try again");
		labReport.setTextFill(Color.RED);

		reportTF.setText("");
	}

	hbReport.getChildren().add(labReport);
	
			
		});

		searchbut.setOnAction(e -> {
			listSerch.getItems().clear();
			Node<Book> curr = library.getHead();

			if (searchTF.getText().isEmpty()) {
				if (library.getHead() == null) {
					listSerch.getItems().add("NOoO BOoK");

				}

				// display all book
				else {
					while (curr != null) {
						listSerch.getItems().add(curr.toString());
						curr = curr.getNext();
					}

				}

			}
			// display specific book
			else {

				String key = searchTF.getText().trim();

				while (curr != null) {
					String str = ((Book) curr.getData()).getAuthor();
					String[] tokens = str.split(",");
					for (int i = 0; i < tokens.length; i++) {
						if (tokens[i].trim().compareTo(key.trim()) == 0) {
							listSerch.getItems().add(curr.toString());
						}
					}

					String subTit = ((Book) curr.getData()).getTitle();
					String toLowSubTit = subTit.toLowerCase();

					if (((Book) curr.getData()).getTitle().compareTo(key.trim()) == 0
							|| toLowSubTit.contains(key.trim())) {
						listSerch.getItems().add(curr.toString());

					}

					curr = curr.getNext();

				}
			}

		});

		saleBut.setOnAction(e -> {
			noSelectedBook.setText("");

			String strlin = listSerch.getSelectionModel().getSelectedItem();

			if (strlin != null) {
				library.Sale(strlin);
				Node<Book> curr = library.getHead();
				//searchTF.setText(strlin);
				listSerch.getItems().clear();

				if (searchTF.getText().trim().compareTo("") == 0) {
					while (curr != null) {
						listSerch.getItems().add(curr.toString());
						curr = curr.getNext();
					}
					
				}
				else {
					while(curr!=null){
						//System.out.println(curr.getData());
						String key=searchTF.getText();
						String subTit = ((Book) curr.getData()).getTitle();
						String toLowSubTit = subTit.toLowerCase();

						if (((Book) curr.getData()).getTitle().compareTo(key.trim()) == 0
								|| toLowSubTit.contains(key.trim())) {
							listSerch.getItems().add(curr.toString());

						}

						
						//////////////////////////////////////////////////////////////////
						String str = ((Book) curr.getData()).getAuthor();
						String[] tokens = str.split(",");
						for (int i = 0; i < tokens.length; i++) {
							if (tokens[i].trim().compareTo(key.trim()) == 0) {
								listSerch.getItems().add(curr.toString());
							}
						}
						
						curr=curr.getNext();
						
					}
				}
				
				
				noSelectedBook.setText("book is sale");
				noSelectedBook.setTextFill(Color.GREEN);
				
				
			}
			else {

				noSelectedBook.setText("No Book Selected");
				noSelectedBook.setTextFill(Color.RED);

			}

		});

		addBookBut.setOnAction(e -> {

			hDoneErroe.getChildren().clear();

			try {
				Book book = new Book(authorTF.getText().trim(), titleTF.getText().trim(), editionTF.getText().trim(),
						publisherTF.getText().trim(), Integer.parseInt(priceTF.getText()),
						Integer.parseInt(quantityTF.getText()));
				library.insertSorted(book);
				// set TF Empty
				authorTF.setText("");
				titleTF.setText("");
				editionTF.setText("");
				publisherTF.setText("");
				priceTF.setText("");
				quantityTF.setText("");

				doneError.setText("Input successfully");
				doneError.setTextFill(Color.GREEN);

			} catch (Exception s) {
				doneError.setText("Please be sure to input");
				doneError.setTextFill(Color.RED);
			}
			hDoneErroe.getChildren().add(doneError);
		});
		
		vBox.getChildren().add(hBoxAddBook);

		addBook.setOnAction(e -> {
			listSerch.getItems().clear();
			addBook.setDisable(true);
			search.setDisable(false);
			display.setDisable(false);
			report.setDisable(false);
			vBox.getChildren().add(hBoxAddBook);
			vBox.getChildren().remove(vBoxReport);
			vBox.getChildren().remove(hboxdisplay);
			vBox.getChildren().remove(vBoxSearch);

		});

		display.setOnAction(e -> {
			listSerch.getItems().clear();
			addBook.setDisable(false);
			search.setDisable(false);
			display.setDisable(true);
			report.setDisable(false);
			vBox.getChildren().add(hboxdisplay);
			vBox.getChildren().remove(hBoxAddBook);
			vBox.getChildren().remove(vBoxSearch);
			vBox.getChildren().remove(vBoxSearch);
			listDisplay.getItems().clear();
			Node<Book> curr = library.getHead();
			if (curr == null) {
				listDisplay.getItems().add("NOoO BOoK");
				
			}
			while (curr != null) {

				listDisplay.getItems().add(curr.toString());
				curr = curr.getNext();
			}

		});
		search.setOnAction(e -> {
			addBook.setDisable(false);
			search.setDisable(true);
			display.setDisable(false);
			report.setDisable(false);
			listSerch.getItems().clear();
			vBox.getChildren().remove(hBoxAddBook);
			vBox.getChildren().add(vBoxSearch);
			vBox.getChildren().remove(hboxdisplay);
			vBox.getChildren().remove(vBoxReport);

		});
		report.setOnAction(e -> {
			listSerch.getItems().clear();
			addBook.setDisable(false);
			search.setDisable(false);
			display.setDisable(false);
			report.setDisable(true);
			vBox.getChildren().add(vBoxReport);
			vBox.getChildren().remove(hBoxAddBook);
			vBox.getChildren().remove(vBoxSearch);
			vBox.getChildren().remove(hboxdisplay);

		});
		
		
		
		Scene scene = new Scene(pane, 600, 600);
		ps.setScene(scene);
		ps.setTitle("Book store");
		ps.show();
		ps.setResizable(false);

	}

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		launch(args);
	}

}
