import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class LinkedList<T> {
	Node<T> head;

	public Node<T> getHead() {
		return head;
	}

	public void setHead(Node<T> head) {
		this.head = head;
	}

	public boolean isEmpty() {
		return head == null;
	}

	public int length() {
		if (this.isEmpty())
			return 0;
		else {
			int counter = 1;
			Node<T> curr = head;
			while (curr.getNext() != null) {
				counter++;
				curr = curr.getNext();
			}
			return counter;
		}
	}

	public void insertAtHead(T data) {
		Node<T> curr = head;
		Node<T> newNode = new Node<>(data);
		head = newNode;
		newNode.setNext(curr);
	}

	public void insertSorted(T data) {

		if (head == null) {
			insertAtHead(data);

		}

		else {
			Node<T> curr = head, priv = null;
			Node<T> newNode = new Node<>(data);
			while (curr != null && (((Book) newNode.getData()).getTitle())
					.compareToIgnoreCase(((Book) curr.getData()).getTitle()) != 0) {

				curr = curr.getNext();
			}
			boolean check = true;
			// quatity
			if (curr != null) {
				int newQuan = ((Book) newNode.getData()).getQuantity();
				int currQuan = ((Book) curr.getData()).getQuantity();

				((Book) curr.getData()).setQuantity(newQuan + currQuan);
				check = false;
			}
			curr = head;
			while (check == true && curr != null && (((Book) newNode.getData()).getTitle())
					.compareToIgnoreCase(((Book) curr.getData()).getTitle()) > 0) {

				priv = curr;
				curr = curr.getNext();
			}
			if (check == true && priv == null)
				insertAtHead(data);
			else if (check == true) {
				newNode.setNext(curr);
				priv.setNext(newNode);
			}

		}

	}

	public Node<T> Sale(String book) {

		Node<T> curr = head;
		Node<T> priv = null;
		while (curr != null) {
			if (curr.toString().trim().compareTo(book.trim()) == 0)
				break;
			priv = curr;
			curr = curr.getNext();
		}

		if (((Book) curr.getData()).getQuantity() > 1 && curr != null)
			((Book) curr.getData()).setQuantity(((Book) curr.getData()).getQuantity() - 1);

		else if (curr != null) {

			if (curr == head) {
				head = head.getNext();

			} else if (curr.getNext() == null) {
				priv.setNext(null);

			} else {
				priv.setNext(curr.getNext());
				curr.setNext(null);

			}
			return curr;
		}

		/////////////////////////////////// check
		return curr;

	}

	public String toString() {

		String res = "";
		Node<T> curr = head;
		while (curr != null) {
			res += curr + "\n";
			curr = curr.getNext();
		}
		return res;
	}

	public void downLoadInFile() throws FileNotFoundException {
		File file = new File("file.txt");
		PrintWriter output = new PrintWriter(file);
		Node<T> curr = head;
		while (curr != null) {
			output.println(curr.getData());

			curr = curr.getNext();
		}

		// file close
		output.close();
	}

}